//******************************************************************************
// Abfrage einer 4x4 Matrix-Tastatur
// Programmierer:	Ingo Schick
// Datum:			08.04.2007
//******************************************************************************
#include <P18F46K80.h>			// PIC18F46K80 auswhlen
#define Matrix 	 PORTB

//*****************************************************************************
//Matrix-Tastatur-Ausgnge
//*****************************************************************************
#define MATRIX_O0  PORTBbits.RB0
#define MATRIX_O1  PORTBbits.RB1
#define MATRIX_O2  PORTBbits.RB2
#define MATRIX_O3  PORTBbits.RB3
//*****************************************************************************

//*****************************************************************************
//Matrix-Tastatur-Eingnge
//*****************************************************************************
#define MATRIX_I0  PORTBbits.RB4
#define MATRIX_I1  PORTBbits.RB5
#define MATRIX_I2  PORTBbits.RB6
#define MATRIX_I3  PORTBbits.RB7
//*****************************************************************************


//*****************************************************************************
//Init_Tastatur Die Eingnge mssen auf 0 sein
//*****************************************************************************
void Matrix_Init(void)
{
 	MATRIX_I0 = 0;       // Matrix-Eingang 0 auf Low setzen
 	MATRIX_I1 = 0;       // Matrix-Eingang 1 auf Low setzen
	MATRIX_I2 = 0;       // Matrix-Eingang 2 auf Low setzen
	MATRIX_I3 = 0;       // Matrix-Eingang 3 auf Low setzen
}
//*****************************************************************************


//*****************************************************************************
// Alle Matrix-Ausgnge auf High setzen (Matrix aktivieren)
//*****************************************************************************
void Matrix_aktivieren(void)
{
 	MATRIX_I0 = 1;       // Matrix-Eingang 0 auf High setzen
	MATRIX_I1 = 1;       // Matrix-Eingang 1 auf High setzen
	MATRIX_I2 = 1;       // Matrix-Eingang 2 auf High setzen
 	MATRIX_I3 = 1;       // Matrix-Eingang 3 auf High setzen
}
//*****************************************************************************


unsigned char Matrix_Auslesen()
{
 unsigned char unc_Taste;
//*****************************************************************************
	Matrix_aktivieren();
//*****************************************************************************
	unc_Taste = ' ';
//*****************************************************************************
// Spalte 1 (Tasten 1, 4, 7 und * auslesen)
//*****************************************************************************	
	// Vorbelegung
 	MATRIX_O0 = 0;       // Matrix-Ausgang 0 auf Low setzen
 	MATRIX_O1 = 1;       // Matrix-Ausgang 1 auf High setzen
 	MATRIX_O2 = 1;       // Matrix-Ausgang 2 auf High setzen
 	MATRIX_O3 = 1;       // Matrix-Ausgang 3 auf High setzen
 	
	switch (Matrix) {
						case 238:	unc_Taste = '1';
						break;
	
						case 222:	unc_Taste = '4';
						break;
	
						case 190:	unc_Taste = '7';
						break;
	
						case 126:	unc_Taste = '*';
						break;
	}
//*****************************************************************************

//*****************************************************************************
// Spalte 2 (Tasten 2, 5, 8 und 0 auslesen)
//*****************************************************************************
	// Vorbelegung
	MATRIX_O0 = 1;       // Matrix-Ausgang 0 auf High setzen
	MATRIX_O1 = 0;       // Matrix-Ausgang 1 auf Low setzen
	MATRIX_O2 = 1;       // Matrix-Ausgang 2 auf High setzen
 	MATRIX_O3 = 1;       // Matrix-Ausgang 3 auf High setzen
	
 	switch (Matrix) {
						case 237:	unc_Taste = '2';
						break;

						case 221:	unc_Taste = '5';
						break;

						case 189:	unc_Taste = '8';
						break;

						case 125:	unc_Taste = '0';
						break;
					}
//*****************************************************************************	

//*****************************************************************************
// Spalte 3 (Tasten 3, 6, 9 und # auslesen)
//*****************************************************************************
	// Vorbelegung
 	MATRIX_O0 = 1;       // Matrix-Ausgang 0 auf High setzen
 	MATRIX_O1 = 1;       // Matrix-Ausgang 1 auf High setzen
 	MATRIX_O2 = 0;       // Matrix-Ausgang 2 auf Low setzen
 	MATRIX_O3 = 1;       // Matrix-Ausgang 3 auf High setzen
	
	switch (Matrix) {
						case 235:	unc_Taste = '3';
						break;
	
						case 219:	unc_Taste = '6';
						break;
			
						case 187:	unc_Taste = '9';
						break;
	
						case 123:	unc_Taste = '#';
						break;
					}	
//*****************************************************************************

//*****************************************************************************
// Spalte 4 (Tasten A, B, C und D auslesen)
//*****************************************************************************
	// Vorbelegung
 	MATRIX_O0 = 1;       // Matrix-Ausgang 0 auf High setzen
 	MATRIX_O1 = 1;       // Matrix-Ausgang 1 auf High setzen
 	MATRIX_O2 = 1;       // Matrix-Ausgang 2 auf High setzen
 	MATRIX_O3 = 0;       // Matrix-Ausgang 3 auf Low setzen
 
 	switch (Matrix) {
						case 231:	unc_Taste = 'A';
						break;

						case 215:	unc_Taste = 'b';
						break;

						case 183:	unc_Taste = 'C';
						break;

						case 119:	unc_Taste = 'd';
						break;
					}
//*****************************************************************************	
	return unc_Taste;
//*****************************************************************************
}
//*****************************************************************************
