/************************************************************************/
// 4x4 Matrix-Tastatur Beispiel Nr. 1
// Programmierer: Fa. Schwabenplan, Ingo Schick
// Datum: 31.08.2014
/************************************************************************/

/************************************************************************/
//Include Dateien
/************************************************************************/
#include <p18f46k80.h>				// PIC18F46K80 auswhlen
#include <stdio.h>				// Standard-Bibiotheken einbeziehen
#include "SP_PIC18F46K80.H"
#include "Warten_MS.H"
#include "Segment.H"
#include "4x4_Matrix.H"
#include "USART.H"
/************************************************************************/

/************************************************************************/
// Microcontroller-Konfiguration
/************************************************************************/
// CONFIG1L
#pragma config RETEN = OFF    
#pragma config INTOSCSEL = LOW 
#pragma config SOSCSEL = DIG
#pragma config XINST = OFF

// CONFIG1H 
#pragma config FOSC = HS2       // Oscillator (HS oscillator (Medium power, 16 MHz - 25 MHz)) 
#pragma config PLLCFG = OFF      
#pragma config FCMEN = OFF       
#pragma config IESO = OFF      

// CONFIG2L 
#pragma config PWRTEN = OFF     // Power Up Timer (Disabled) 
#pragma config BOREN = OFF 
#pragma config BORV = 3         // Brown-out Reset Voltage bits (1.8V) 
#pragma config BORPWR = ZPBORMV // BORMV Power level (ZPBORMV instead of BORMV is selected) 

// CONFIG2H 
#pragma config WDTEN = SWDTDIS  // Watchdog Timer (WDT enabled in hardware; SWDTEN bit disabled) 
#pragma config WDTPS = 1048576  // Watchdog Postscaler (1:1048576) 

// CONFIG3H 
#pragma config CANMX = PORTC    // ECAN Mux bit (ECAN TX and RX pins are located on RB2 and RB3, respectively) 
#pragma config MSSPMSK = MSK7   // MSSP address masking (7 Bit address masking mode) 
#pragma config MCLRE = ON       // Master Clear Enable (MCLR Enabled, RG5 Disabled) 

// CONFIG4L 
#pragma config STVREN = OFF      // Stack Overflow Reset (Disabled) 
#pragma config BBSIZ = BB2K     // Boot Block Size (2K word Boot Block size) 

// CONFIG5L 
#pragma config CP0 = OFF        // Code Protect 00800-03FFF (Disabled) 
#pragma config CP1 = OFF        // Code Protect 04000-07FFF (Disabled) 
#pragma config CP2 = OFF        // Code Protect 08000-0BFFF (Disabled) 
#pragma config CP3 = OFF        // Code Protect 0C000-0FFFF (Disabled) 

// CONFIG5H 
#pragma config CPB = OFF        // Code Protect Boot (Disabled) 
#pragma config CPD = OFF        // Data EE Read Protect (Disabled) 

// CONFIG6L 
#pragma config WRT0 = OFF       // Table Write Protect 00800-03FFF (Disabled) 
#pragma config WRT1 = OFF       // Table Write Protect 04000-07FFF (Disabled) 
#pragma config WRT2 = OFF       // Table Write Protect 08000-0BFFF (Disabled) 
#pragma config WRT3 = OFF       // Table Write Protect 0C000-0FFFF (Disabled) 

// CONFIG6H 
#pragma config WRTC = OFF       // Config. Write Protect (Disabled) 
#pragma config WRTB = OFF       // Table Write Protect Boot (Disabled) 
#pragma config WRTD = OFF       // Data EE Write Protect (Disabled) 

// CONFIG7L 
#pragma config EBTR0 = OFF      // Table Read Protect 00800-03FFF (Disabled) 
#pragma config EBTR1 = OFF      // Table Read Protect 04000-07FFF (Disabled) 
#pragma config EBTR2 = OFF      // Table Read Protect 08000-0BFFF (Disabled) 
#pragma config EBTR3 = OFF      // Table Read Protect 0C000-0FFFF (Disabled) 

// CONFIG7H 
#pragma config EBTRB = OFF      // Table Read Protect Boot (Disabled) 
/************************************************************************/


/************************************************************************/
// sonstige Deklarationen
/************************************************************************/
#define True			1
#define False			0	
/************************************************************************/

/************************************************************************/
// Hauptprogramm
/************************************************************************/

void main(void)
{
	
	unsigned char unc_Taste;
		
  	ANCON1 = 0;						// AN8 - AN10 auf Digitalbetrieb umschalten			 					
  	TRISB = 0x00;					// PORTB initalisieren
  	PORTB = 0x00;
  	LATB = 0x00;
  	
  	TRISC= 0b01011000;     			// PORTC initalisieren
    LATC= 0b01011000;
    
    Init_USART(19200);					
	
  	TRISD = 0x00;					// PORTD initalisieren
  	PORTD = 0x00;
  	LATD = 0x00;				
  	
//*****************************************************************************
// Start der Hauptprogramm-Schleife 
//*****************************************************************************	
  	
 while(1)                		// Ganzes Programm ist Endlosschleife
 {     
	    
	    unc_Taste = Matrix_Auslesen();
	    Zeichen_Anzeigen(unc_Taste);
			
        printf("%.1c", unc_Taste);
	 	printf("\r\n");
        
	    printf("%.3u", LATD);
	 	printf("\r\n");
        
        
        
	 	Warten_MS(100);			
 }
//*****************************************************************************		
 }	// Ende des Hauptprogramm
//*****************************************************************************	
